<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>Xsens Device API Objectives and Considerations</title>
<link href="xsens.css" rel="stylesheet" type="text/css"/>
</head><body>
<img class="logo" src="xsenslogo.jpg" alt="Xsens Logo" />
	<!-- Generated by Doxygen 1.8.11 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Xsens Device API Objectives and Considerations </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><div class="readabledox"></div><div class="readabledox"></div><h1><a class="anchor" id="s_objectives"></a>
Objectives</h1>
<div class="readabledox">The main objective of the SDK is that developers are able to easily implement host applications that use Xsens motion trackers. Further objectives are that the SDK is: <ul>
<li>easy to understand, </li>
<li>easy to use, </li>
<li>logical and straightforward, </li>
<li>preventing mistakes, </li>
<li>future proof, </li>
<li>platform independent, </li>
<li>useable by a large variety of developers.</li>
</ul>
</div><h1><a class="anchor" id="s_considerations"></a>
Considerations</h1>
<div class="readabledox"></div><div class="readabledox"> When supplying an SDK one faces a number of decisions as discussed in the following sections.</div><div class="readabledox"></div><h2><a class="anchor" id="ss_language"></a>
Language</h2>
<div class="readabledox"></div><div class="readabledox"> The first decision is what programming language to choose. This depends a lot on the market. Xsens technology is often used in industrial and research settings. As such, candidates could for example be: Java, C, C++, Objective-C, Python. An important evaluation is that all these languages can handle a C interface. Therefore an obvious choice is to supply a C interface.</div><div class="readabledox"></div><div class="readabledox"> However, C is not an object-oriented language. There are good reasons for choosing object-oriented language when developing complex systems, especially with elaborate GUI and concurrency (This is for example supported by state-of-the art frameworks like Qt). Xsens therefore internally uses C++ to develop software. However, this does not mean that the SDK interface libraries necessarily have to be implemented in C++ as well.</div><div class="readabledox">Some other advantages and disadvantages between C and C++ are given in the following table: <br />
<br />
 
<table class="doxtable">

<tr>
<th> C </th>
<th> C++ </th>

<tr>
<td> - Manual object-lifetime management </td>
<td> + Easy object-lifetime management. </td>

<tr>
<td> - Difficult to deal with complex objects. </td>
<td> + Easily handle complex objects. </td>

<tr>
<td> - Easy to make mistakes. </td>
<td> + Harder to make mistakes. </td>

<tr>
<td> + Widely accepted and standardized interface. </td>
<td> - Only C++ compatible. </td>

<tr>
<td> + Not compiler dependent. </td>
<td> - Compiler dependent. </td>

<tr>
<td> - Platform dependent. </td>
<td> - Platform dependent. </td>

</table>
 <dl class="section note"><dt>Note</dt><dd>platform means combination of OS and processor.</dd></dl>
<br />
Some other considerations for the SDK are given in the following sections.</div><div class="readabledox"></div><h2><a class="anchor" id="ss_nameMangling"></a>
Name mangling</h2>
<div class="readabledox">Due to name-mangling, C++ libraries are not interchangeable between different compilers. There are possible workarounds to go from one compiler to another, but these all require having both compilers installed on the development PC. This means that, if a C++ interface would be used, it must be supplied for every compiler separately. Although this could be organized, it is preferable if this could be avoided.</div><div class="readabledox"></div><h2><a class="anchor" id="ss_genericTypes"></a>
Generic types libraries</h2>
<div class="readabledox">The SDK must include a generic types-library to handle standard data-types like quaternions, vectors and matrices and the standard operation on these types.</div><div class="readabledox"></div><h2><a class="anchor" id="ss_generic"></a>
Generic, complexity and flexibility</h2>
<div class="readabledox">Another problem is that the SDK should support a wide range of devices and the developer should not need to reinstall or rewrite the code whenever a new type of device is used.</div><div class="readabledox"></div><h2><a class="anchor" id="ss_usedInternally"></a>
Used internally</h2>
<div class="readabledox">It will be preferable to use the SDK also for internal development. For example the MT Manager tool is developed using the API as well. However, the interface should not be cluttered with information that is not used by or relevant for the host application developer of the customer.</div><div class="readabledox"></div> </div></div><!-- contents -->

<div class="tabs">&nbsp;</div>
<hr size="1" />
<address style="text-align: right;">
<small>Generated on Thu Jun 29 2017 for Xsens by <a href="http://www.doxygen.org/index.html">Doxygen</a> 1.8.11</small>
</address>
</body>
</html>
